> For the complete documentation index, see [llms.txt](https://docs.nounspace.com/nounspace-alpha/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.nounspace.com/nounspace-alpha/fidgets/fidget-data-storage.md).

# Fidget Data Storage

Fidgets pull data from various different streams and might need to save some of that data.

Data that Fidgets need to save is stored in a database. For the time being, this is stored in a centralized Supabase storage bucket, but down the line this data will be stored in a decentralized manner on IPFS/Arweave.

Data that Fidgets store can be separated into two categories: public and private. Public data is readable by all users while private data can only be read by a specific user.&#x20;

Here's some examples:

* A Fidget that displays Bob's profile picture will place that profile picture into a public bucket, so that all other users that view Bob's profile can see the picture.&#x20;
* A Fidget that allows Bob to sign into Coinbase to purchase more ETH will keep Bob's API key in a private bucket, so that no other users can access that key. Only Bob.

To use these data setters, import these functions from `shared/data/fidgetData.ts:`

```typescript
  readPublicFidgetData
  writePublicFidgetData
  readPrivateFidgetData
  writePivateFidgetData
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.nounspace.com/nounspace-alpha/fidgets/fidget-data-storage.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
